#pragma once

#include <string>
#include <cppamqp/enums.h>
#include <cppamqp/types.h>
#include <cppamqp/config.h>
#include <cppamqp/message.h>
#include <cppamqp/connection.fwd.h>

namespace cppamqp
{

    struct consume_result
    {
    private:
        using message_t = ::cppamqp::message;

        const connection&       _connection;

    public:
        consume_result_type     type;
        message_t               message;
        channel_number          channel;
        std::string             consumer_tag;
        uint64_t                delivery_tag;
        bool                    redelivered;
        std::string             exchange;
        std::string             routing_key;

        inline consume_result(const connection& p_connection, consume_result_type p_type);
        inline consume_result(const connection& p_connection, consume_result_type p_type, const amqp_message_t& p_message);
        inline consume_result(const connection& p_connection, const amqp_envelope_t& p_envelope);
        inline consume_result(consume_result&& other) = default;
        inline consume_result(const consume_result& other) = default;

        inline void ack();
        inline void nack(bool requeue);
    };

}