#pragma once

#include <cppamqp/config.h>
#include <cppcore/misc/flags.h>

namespace cppamqp
{

    enum class delivery_mode
    {
        non_persistent  = AMQP_DELIVERY_NONPERSISTENT,
        persistent      = AMQP_DELIVERY_PERSISTENT,
    };

    enum class consume_result_type
    {
        success,
        timeout,
        acknowledge,
        connection_closed_by_peer,
        could_not_deliver_return_to_sender,
    };

    enum class queue_flag
    {
        passive,
        durable,
        exclusive,
        auto_delete,
    };
    using queue_flags = ::cppcore::shifted_flags<queue_flag>;

    enum class publish_flag
    {
        mandatory,
        immediate,
    };
    using publish_flags = ::cppcore::shifted_flags<publish_flag>;

    enum class consume_flag
    {
        no_local,
        no_ack,
        exclusive,
    };
    using consume_flags = ::cppcore::shifted_flags<consume_flag>;

}
