#pragma once

#include <cppamqp/exception.h>

namespace cppamqp
{

    exception::exception(const std::string& p_message) :
        ::cppcore::exception  (p_message)
        { }

    exception::exception(amqp_status_enum p_status) :
        ::cppcore::exception  (amqp_error_string2(p_status)),
        status          (p_status)
        { }

    exception::exception(const std::string& p_message, amqp_status_enum p_status) :
        ::cppcore::exception  (p_message + " - " + amqp_error_string2(p_status) +
                            "(" + std::to_string(static_cast<int>(p_status)) + ")"),
        status          (p_status)
        { }

}
