#pragma once

#include <cppamqp/enums.h>
#include <cppamqp/config.h>
#include <cppcore/misc/nullable.h>

namespace cppamqp
{

    struct publish_options
    {
    private:
        using delivery_mode_t = ::cppamqp::delivery_mode;

        mutable amqp_basic_properties_t _properties;

    public:
        ::cppcore::nullable<std::string>      content_type;
        ::cppcore::nullable<std::string>      content_encoding;
        ::cppcore::nullable<delivery_mode_t>  delivery_mode;
        ::cppcore::nullable<uint8_t>          priority;
        ::cppcore::nullable<std::string>      correlation_id;
        ::cppcore::nullable<std::string>      reply_to;
        ::cppcore::nullable<std::string>      expiration;
        ::cppcore::nullable<std::string>      message_id;
        ::cppcore::nullable<uint64_t>         timestamp;
        ::cppcore::nullable<std::string>      type;
        ::cppcore::nullable<std::string>      user_id;
        ::cppcore::nullable<std::string>      app_id;
        ::cppcore::nullable<std::string>      cluster_id;

        inline publish_options();
        inline publish_options(const amqp_basic_properties_t& prop);
        inline publish_options(publish_options&& other) = default;
        inline publish_options(const publish_options& other) = default;

        const amqp_basic_properties_t*  properties  () const;
        void                            reset       ();
    };

}
