#pragma once

#include <cppamqp/helper.inl>
#include <cppamqp/publish_options.h>

namespace cppamqp
{

    publish_options::publish_options()
        { }

    publish_options::publish_options(const amqp_basic_properties_t& prop)
    {
        if (prop._flags & AMQP_BASIC_CONTENT_TYPE_FLAG)     content_type     = __impl::from_bytes             (prop.content_type);
        if (prop._flags & AMQP_BASIC_CONTENT_ENCODING_FLAG) content_encoding = __impl::from_bytes             (prop.content_encoding);
        if (prop._flags & AMQP_BASIC_DELIVERY_MODE_FLAG)    delivery_mode    = static_cast<enum delivery_mode>(prop.delivery_mode);
        if (prop._flags & AMQP_BASIC_PRIORITY_FLAG)         priority         =                                 prop.priority;
        if (prop._flags & AMQP_BASIC_CORRELATION_ID_FLAG)   correlation_id   = __impl::from_bytes             (prop.correlation_id);
        if (prop._flags & AMQP_BASIC_REPLY_TO_FLAG)         reply_to         = __impl::from_bytes             (prop.reply_to);
        if (prop._flags & AMQP_BASIC_EXPIRATION_FLAG)       expiration       = __impl::from_bytes             (prop.expiration);
        if (prop._flags & AMQP_BASIC_MESSAGE_ID_FLAG)       message_id       = __impl::from_bytes             (prop.message_id);
        if (prop._flags & AMQP_BASIC_TIMESTAMP_FLAG)        timestamp        =                                 prop.timestamp;
        if (prop._flags & AMQP_BASIC_TYPE_FLAG)             type             = __impl::from_bytes             (prop.type);
        if (prop._flags & AMQP_BASIC_USER_ID_FLAG)          user_id          = __impl::from_bytes             (prop.user_id);
        if (prop._flags & AMQP_BASIC_APP_ID_FLAG)           app_id           = __impl::from_bytes             (prop.app_id);
        if (prop._flags & AMQP_BASIC_CLUSTER_ID_FLAG)       cluster_id       = __impl::from_bytes             (prop.cluster_id);
    }

}