#pragma once

#include <map>
#include <cppamqp/config.h>

namespace cppamqp
{

    struct queue_declaration
    {
        std::string name;
        uint        message_count;
        uint        consumer_count;
    };

    using channel_number = amqp_channel_t;

    struct field_value
        : private amqp_field_value_t
    {
    private:
        template<typename T_value>
        inline void set(T_value&& p_value);

    public:
        inline field_value();

        template<typename T_value>
        inline field_value(T_value&& p_value);

        template<typename T_value>
        inline field_value& operator=(T_value&& p_value);

        inline const amqp_field_value_t& get() const;
    };

    using table = std::map<std::string, field_value>;

    const table empty_table;

}