#pragma once

#include <cppamqp/types.h>

namespace cppamqp
{

    template<>
    inline void field_value::set<bool>(bool&& p_value)
    {
        this->kind = AMQP_FIELD_KIND_BOOLEAN;
        this->value.boolean = static_cast<int>(p_value);
    }

    template<>
    inline void field_value::set<int8_t>(int8_t&& p_value)
    {
        this->kind = AMQP_FIELD_KIND_I8;
        this->value.i8 = p_value;
    }

    template<>
    inline void field_value::set<uint8_t>(uint8_t&& p_value)
    {
        this->kind = AMQP_FIELD_KIND_U8;
        this->value.u8 = p_value;
    }

    template<>
    inline void field_value::set<int16_t>(int16_t&& p_value)
    {
        this->kind = AMQP_FIELD_KIND_I16;
        this->value.i16 = p_value;
    }

    template<>
    inline void field_value::set<uint16_t>(uint16_t&& p_value)
    {
        this->kind = AMQP_FIELD_KIND_U16;
        this->value.u16 = p_value;
    }

    template<>
    inline void field_value::set<int32_t>(int32_t&& p_value)
    {
        this->kind = AMQP_FIELD_KIND_I32;
        this->value.i32 = p_value;
    }

    template<>
    inline void field_value::set<uint32_t>(uint32_t&& p_value)
    {
        this->kind = AMQP_FIELD_KIND_U32;
        this->value.u32 = p_value;
    }

    template<>
    inline void field_value::set<int64_t>(int64_t&& p_value)
    {
        this->kind = AMQP_FIELD_KIND_I64;
        this->value.i64 = p_value;
    }

    template<>
    inline void field_value::set<uint64_t>(uint64_t&& p_value)
    {
        this->kind = AMQP_FIELD_KIND_U64;
        this->value.u64 = p_value;
    }

    template<>
    inline void field_value::set<float>(float&& p_value)
    {
        this->kind = AMQP_FIELD_KIND_F32;
        this->value.f32 = p_value;
    }

    template<>
    inline void field_value::set<double>(double&& p_value)
    {
        this->kind = AMQP_FIELD_KIND_F64;
        this->value.f64 = p_value;
    }


    field_value::field_value()
    {
        this->kind = AMQP_FIELD_KIND_VOID;
    }

    template<typename T_value>
    field_value::field_value(T_value&& p_value)
        { set(std::forward<T_value>(p_value)); }

    template<typename T_value>
    field_value& field_value::operator=(T_value&& p_value)
    {
        set(std::forward<T_value>(p_value));
        return *this;
    }

    inline const amqp_field_value_t& field_value::get() const
        { return *this; }

}